import org.apache.poi.openxml4j.opc.OPCPackage;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellReference;
import org.apache.poi.xssf.usermodel.*;

public class test {
	public static void main(String args[]) throws Exception {
		OPCPackage pkg = OPCPackage.open(args[0]);
		XSSFWorkbook wb = new XSSFWorkbook(pkg);
		FormulaEvaluator evaluator = wb.getCreationHelper().createFormulaEvaluator();
		for(XSSFSheet sheet : wb) {
			System.out.println(sheet.getSheetName());
			for (Row row : sheet) {
				for (Cell cell : row) {
					CellReference cellRef = new CellReference(row.getRowNum(), cell.getColumnIndex());
					System.out.print(cellRef.formatAsString());
					System.out.print(" - ");

					switch (cell.getCellType()) {
						case Cell.CELL_TYPE_STRING:
							System.out.println(cell.getRichStringCellValue().getString());
							break;
						case Cell.CELL_TYPE_NUMERIC:
							if (DateUtil.isCellDateFormatted(cell)) {
								System.out.println(cell.getDateCellValue());
							} else {
								System.out.println(cell.getNumericCellValue());
							}
							break;
						case Cell.CELL_TYPE_BOOLEAN:
							System.out.println(cell.getBooleanCellValue());
							break;
						case Cell.CELL_TYPE_FORMULA:
							String formula = cell.getCellFormula();
						        System.out.print(formula);
							CellValue cellValue = evaluator.evaluate(cell);
							switch (cellValue.getCellType()) {
								case Cell.CELL_TYPE_NUMERIC:
									double v = cellValue.getNumberValue();
									if (DateUtil.isCellDateFormatted(cell)) {
										System.out.println("[isCellDateFormatted=true] = " + DateUtil.getJavaDate(v, true));
									} else {
										System.out.println("[isCellDateFormatted=false] = " + v);
									} // end if-else
									break;
								default:
									System.out.println(" = " + cellValue.getStringValue());
									System.out.println("\t\tgetStringCellValue(): " + cell.getStringCellValue());
							}
							break;
						default:
						        System.out.println("");
					} // end switch
				} // end for
			} // end for
		} // end for
		pkg.close(); // gracefully closes the underlying zip file
	} // end main()
} // end class